/* Async.c
 *
 * Object code interpreter for packet script program. Also contains
 * PC specific code for send stuff out the serial port.
 *
 * This code was written based on the original Mac specific code
 * by Ken Rice.
 *
 * Copyright 1996 by Brian Barnt and Kenneth Rice
 *
 * You may freely distribute this source code, and use all or part of
 * this source code in all software including commercial, freeware,
 * shareware and private applications.
 *
 * Please report bugs, fixes, etc to me at:
 *   73457,1510 (compuserve)
 *
 * Created	05/30/96
 *
 *
 *
 */

#include "portasnc.h"
#include "pktscrpt.h"
#include "bc_sio.h"

extern   unsigned     mdm_putc(char ch);

typedef struct tagMyParamBlock
{
   int   running;    // true if sending serial data
   int   setBySend;
   AsynchDataPtr  *pAppData;  // opaque ptr to App data
   int   err;                 
} MyParamBlockRec, *MyParamBlockPtr;


// SendBytes sends BytesInBuf characters pointed to by pBuf out the "serial" 
// port.  pAppData is a pointer to the application's data table of 
// information to send.  pSenderData is the async parameter block used when
// sending serial data in a multi-tasking environment.


void	SendBytes(unsigned char *pBuf, long bytesInBuf,AsynchDataPtr pAppData, AsynchDataPtr pSenderData, char OutputType)
{
   MyParamBlockPtr   pParams;
   long              lCount;
   int               iChr;

   pParams = (MyParamBlockPtr) pSenderData;


   pParams->pAppData = pAppData;
	pParams->setBySend = 1;

   if (OutputType == OT_SERIAL)
      {
      for(lCount = 0; lCount < bytesInBuf; ++lCount)
         {
         if (kb_hit())
            {
            iChr = kb_getc();
            if (iChr == 0x1B)
                  break;
            }
         mdm_putc(*pBuf++);
         }
      }

   if (OutputType == OT_SENDER)
      {
//
// Version 0.95
//
      clr_under();
      send_pkt(pBuf,bytesInBuf);
//
//      build_pkt(pBuf,bytesInBuf);
      }

#ifdef DBUG

//
// This section of code was used to verify the output of the makepacket
// routine.  It is commented out, and will not be compiled.
//

   // Print Bytes

   printf("\n");

   for(lCount = 0; lCount < bytesInBuf; ++lCount)
      {
      switch (*pBuf++)
         {
         case 0xF0:
            printf("0");
            break;
         case 0xC6:
            printf("00");
            break;
         case 0x78:
            printf("01");
            break;
         case 0xE1:
            printf("10");
            break;
         case 0x66:
            printf("001");
            break;
         case 0x96:
            printf("010");
            break;
         case 0x5C:
            printf("011");
            break;
         case 0x99:
            printf("100");
            break;
         case 0x71:
            printf("101");
            break;
         case 0xc5:
            printf("110");
            break;
         case 0x56:
            printf("0111");
            break;
         case 0x59:
            printf("1011");
            break;
         case 0x65:
            printf("1101");
            break;
         case 0x95:
            printf("1110");
            break;
         case 0x55:
            printf("11111");
            break;
         default:
            printf(" ???? ");
         }
      }
#endif

}

